"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var path = require('path');
var prompts = require('prompts');
var fs = require('fs-extra');
var log = require('npmlog');
var spawn = require('@npmcli/promise-spawn');
var updateChangelogForPackage = require('./updateChangelogForPackage');
var logReleasingPackages = require('./logReleasingPackages');
var promptForVersionType = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee() {
    var _yield$prompts, versionType;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          // Pause the npm logger while we prompt for the type of release we want to perform
          log.pause();
          _context.next = 3;
          return prompts([{
            type: 'select',
            name: 'versionType',
            message: 'What type of release do you want to version for?',
            choices: [{
              title: 'major',
              value: 'major'
            }, {
              title: 'minor',
              value: 'minor'
            }, {
              title: 'patch',
              value: 'patch'
            }],
            pageSize: 3
          }]);
        case 3:
          _yield$prompts = _context.sent;
          versionType = _yield$prompts.versionType;
          log.resume();
          return _context.abrupt("return", versionType);
        case 7:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function promptForVersionType() {
    return _ref.apply(this, arguments);
  };
}();
module.exports = /*#__PURE__*/(0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee2() {
  var versionType, _yield$spawn, stdout, _yield$fs$readJSON, packageName;
  return _regenerator.default.wrap(function _callee2$(_context2) {
    while (1) switch (_context2.prev = _context2.next) {
      case 0:
        _context2.next = 2;
        return promptForVersionType();
      case 2:
        versionType = _context2.sent;
        _context2.next = 5;
        return spawn('npm', ['--no-git-tag-version', 'version', versionType], {
          stdioString: true
        });
      case 5:
        _yield$spawn = _context2.sent;
        stdout = _yield$spawn.stdout;
        _context2.next = 9;
        return updateChangelogForPackage(process.cwd());
      case 9:
        _context2.next = 11;
        return fs.readJSON(path.join(process.cwd(), 'package.json'));
      case 11:
        _yield$fs$readJSON = _context2.sent;
        packageName = _yield$fs$readJSON.name;
        logReleasingPackages(["".concat(packageName, "@").concat(stdout.substring(1))]);
      case 14:
      case "end":
        return _context2.stop();
    }
  }, _callee2);
}));