"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var path = require('path');
var fs = require('fs-extra');
module.exports = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(packagePath) {
    var packageFile, changelogFile, releaseDate, _yield$fs$readJSON, version, regex, changelog, unreleasedContent, releaseContent, _unreleasedContent, captureGroup, changelogDoc, updatedChangelog;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          packageFile = path.resolve(packagePath, 'package.json');
          changelogFile = path.resolve(packagePath, 'CHANGELOG.md');
          releaseDate = new Date().toLocaleString('en-us', {
            month: 'long',
            year: 'numeric',
            day: 'numeric'
          });
          _context.next = 5;
          return fs.pathExists(packageFile);
        case 5:
          _context.t0 = !_context.sent;
          if (_context.t0) {
            _context.next = 10;
            break;
          }
          _context.next = 9;
          return fs.pathExists(changelogFile);
        case 9:
          _context.t0 = !_context.sent;
        case 10:
          if (!_context.t0) {
            _context.next = 12;
            break;
          }
          return _context.abrupt("return");
        case 12:
          _context.next = 14;
          return fs.readJSON(packageFile);
        case 14:
          _yield$fs$readJSON = _context.sent;
          version = _yield$fs$readJSON.version;
          regex = /## Unreleased\n*([^#]*)/;
          _context.next = 19;
          return fs.readFile(changelogFile, 'utf-8');
        case 19:
          changelog = _context.sent;
          // Grab any content in the unreleased section until the next heading (#).
          unreleasedContent = changelog.match(regex); // Default message
          releaseContent = ['* Changed', '  * Minor dependency version bump.', '', ''].join('\n');
          _unreleasedContent = (0, _slicedToArray2.default)(unreleasedContent, 2), captureGroup = _unreleasedContent[1]; // If there was content, don't use the default content.
          if (captureGroup) {
            releaseContent = captureGroup;
          }

          // setup change log entry
          changelogDoc = ['## Unreleased', '', "## ".concat(version, " - (").concat(releaseDate, ")"), '', releaseContent].join('\n'); // Swap in change log entry
          updatedChangelog = changelog.replace(regex, changelogDoc); // write out file.
          _context.next = 28;
          return fs.writeFile(changelogFile, updatedChangelog, {
            encoding: 'utf8',
            flag: 'w'
          });
        case 28:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();