"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var spawn = require('@npmcli/promise-spawn');

/**
 * Sets up git for travis CI using the GITHUB_TOKEN environment variable
 */
module.exports = /*#__PURE__*/(0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee() {
  var travis, remoteUrl, token, newUrl;
  return _regenerator.default.wrap(function _callee$(_context) {
    while (1) switch (_context.prev = _context.next) {
      case 0:
        travis = process.env.TRAVIS;
        if (!travis) {
          _context.next = 13;
          break;
        }
        _context.next = 4;
        return spawn('git', ['config', '--global', 'user.email', 'travis@travis-ci.org'], {
          stdioString: true
        });
      case 4:
        _context.next = 6;
        return spawn('git', ['config', '--global', 'user.name', 'Travis CI'], {
          stdioString: true
        });
      case 6:
        _context.next = 8;
        return spawn('git', ['config', '--get', 'remote.origin.url'], {
          stdioString: true
        });
      case 8:
        remoteUrl = _context.sent.stdout.trim();
        token = process.env.GITHUB_TOKEN;
        newUrl = remoteUrl.replace('https://', "https://".concat(token, "@"));
        _context.next = 13;
        return spawn('git', ['remote', 'set-url', 'origin', newUrl], {
          stdio: 'ignore',
          stdioString: true
        });
      case 13:
      case "end":
        return _context.stop();
    }
  }, _callee);
}));